<template>
  <Filters
    @reset-form="data = []"
    @run-search="() => filterData(filters)"
    :report-button="true"
    class="mb-4"
  >
    <Type2 @update:filters="(value) => (filters = value)" />
  </Filters>

  <div id="data">
    <DxDataGrid
      ref="dataGridRef"
      :allow-column-reordering="true"
      class="max-h-[calc(100vh-140px)] mb-10"
      :data-source="data"
      :show-column-lines="true"
      :show-row-lines="false"
      :show-borders="true"
      :row-alternation-enabled="true"
      :hover-state-enabled="true"
      @selection-changed="onSelectionChanged"
      @exporting="onExporting"
      :allow-column-resizing="true"
      column-resizing-mode="widget"
      :word-wrap-enabled="true"
    >
      <DxSelection mode="single" />
      <DxPaging :enabled="false" />
      <DxScrolling column-rendering-mode="virtual" mode="virtual" />
      <DxLoadPanel
        shading-color="rgba(0,0,0,0.4)"
        :position="position"
        :show-indicator="showIndicator"
        :show-pane="showPane"
        :shading="shading"
        v-model:visible="loading"
        :enabled="true"
      />
      <DxSearchPanel :visible="true" :highlight-case-sensitive="true" />
      <DxExport
        :enabled="true"
        :formats="['pdf', 'xlsx', 'document']"
        :allow-export-selected-data="false"
      />
      <DxColumnFixing :enabled="true" />

      <DxColumn
        :width="50"
        alignment="center"
        :calculateCellValue="(item: any) => data.findIndex((i) => i == item) + 1"
        caption="NO"
        css-class="custom-table-column"
        cell-template="formatNumber"
      />
      <DxColumn
        alignment="center"
        data-field="id_jenis_keluhan"
        caption="ID Keluhan"
        css-class="custom-table-column"
        cell-template="formatText"
      />
      <DxColumn
        alignment="center"
        data-field="nama_jenis_keluhan"
        caption="Jenis Keluhan"
        css-class="custom-table-column"
        cell-template="formatText"
      />
      <DxColumn
        :width="170"
        alignment="center"
        data-field="jumlah"
        caption="Jumlah"
        css-class="custom-table-column"
        cell-template="formatNumber"
      />
      <DxColumn
        :width="70"
        alignment="center"
        data-field="persen"
        caption="%"
        css-class="custom-table-column"
        cell-template="formatNumber"
      />

      <DxSummary>
        <DxTotalItem
          summary-type="sum"
          display-format="TOTAL"
          show-in-column="id_jenis_keluhan"
          css-class="text-white !text-left"
        />
        <DxTotalItem
          column="jumlah"
          summary-type="sum"
          display-format="{0}"
          css-class="text-white !text-right"
          :customize-text="(e: any) => formatNumber(e.value)"
        />
        <DxTotalItem
          column="persen"
          summary-type="avg"
          display-format="{0}"
          css-class="text-white !text-right"
          :customize-text="(e: any) => formatPercentage(e.value)"
        />
      </DxSummary>

      <template #formatNumber="{ data }">
        <p class="text-right">
          {{
            isNumber(data.text)
              ? data.column.caption == '%'
                ? formatPercentage(data.text)
                : formatNumber(data.text)
              : data.text
          }}
        </p>
      </template>

      <template #formatText="{ data }">
        <p class="!text-left">
          {{ data.text }}
        </p>
      </template>
    </DxDataGrid>
  </div>
</template>

<script setup lang="ts">
import { onMounted, ref } from 'vue'
import Filters from '@/components/Form/Filters.vue'
import Type2 from '@/components/Form/FiltersType/Type2.vue'
import { DxDataGrid } from 'devextreme-vue'
import {
  DxColumn,
  DxColumnFixing,
  DxExport,
  DxLoadPanel,
  DxPaging,
  DxScrolling,
  DxSearchPanel,
  DxSelection,
  DxSummary,
  DxTotalItem
} from 'devextreme-vue/data-grid'
import { jsPDF } from 'jspdf'
import { exportDataGrid as exportToPdf } from 'devextreme/pdf_exporter'
import { exportDataGrid as exportToExcel } from 'devextreme/excel_exporter'
import { saveAs } from 'file-saver'
import { Workbook } from 'exceljs'
import { useQuery } from '@vue/apollo-composable'
import { formatNumber, formatPercentage, isNumber } from '@/utils/numbers'
import gql from 'graphql-tag'

const position = { of: '#data' }
const showIndicator = ref(true)
const shading = ref(true)
const showPane = ref(true)
const data = ref<any[]>([])
const filters = ref()
const currentYear = ref(new Date().getFullYear())
const currentMonth = ref(new Date().getMonth() + 1)
const lastYear = ref(new Date().getFullYear() - 1)

const onExporting = (e: any) => {
  if (e.format === 'pdf') {
    const doc = new jsPDF()

    exportToPdf({
      jsPDFDocument: doc,
      component: e.component,
      indent: 5
    }).then(() => {
      doc.save(`.pdf`)
    })
  } else {
    const workbook = new Workbook()
    const worksheet = workbook.addWorksheet('Employees')

    exportToExcel({
      component: e.component,
      worksheet,
      autoFilterEnabled: true
    }).then(() => {
      workbook.xlsx.writeBuffer().then((buffer: any) => {
        saveAs(new Blob([buffer], { type: 'application/octet-stream' }), 'DataGrid.xlsx')
      })
    })

    e.cancel = true
  }
}
const dataGridRef = ref<DxDataGrid | null>(null)
const clearSelection = () => {
  const dataGrid = dataGridRef.value!.instance!
  dataGrid.clearSelection()
}
const onSelectionChanged = ({ selectedRowsData }: any) => {
  const data = selectedRowsData[0]
  clearSelection()
}
const monalisaGangguanPerJenisKeluhan = gql`
  query DaftarmonalisaGangguanPerJenisKeluhan(
    #$regional: String
    $idUlp: Int
    $idUid: Int
    $idUp3: Int
    $bulan: Int
    $tahun: Int
  ) {
    monalisaGangguanPerJenisKeluhan(
      #regional: $regional
      idUlp: $idUlp
      idUid: $idUid
      idUp3: $idUp3
      bulan: $bulan
      tahun: $tahun
    ) {
      id_jenis_keluhan
      nama_jenis_keluhan
      jumlah
      persen
    }
  }
`
const { onResult, onError, loading, refetch } = useQuery(monalisaGangguanPerJenisKeluhan, {
  bulan: currentMonth.value,
  tahun: currentYear.value,
  // regional: '',
  idUlp: 0,
  idUid: 0,
  idUp3: 0
})
const filterData = (params: any) => {
  const { regional, ulp, uid, up3, bulan, tahun } = params

  currentYear.value = tahun.id
  currentMonth.value = bulan.id
  lastYear.value = tahun.id - 1

  refetch({
    // regional: regional,
    idUlp: ulp ? ulp.id : 0,
    idUid: uid ? uid.id : 0,
    idUp3: up3 ? up3.id : 0,
    bulan: bulan ? bulan.id : currentMonth.value,
    tahun: bulan ? tahun.id : currentYear.value
  })

  onResult((queryResult) => {
    if (queryResult.data != undefined) {
      data.value = queryResult.data.monalisaGangguanPerJenisKeluhan
    }
    console.log(queryResult.data)
  })

  onError((error) => {
    console.log(error)
  })
}

onMounted(() => {
  if (import.meta.env.DEV) {
    data.value = [
      {
        id_jenis_keluhan: 1,
        nama_jenis_keluhan: 'Umum',
        jumlah: 802596,
        persen: 100
      }
    ]
  }
})
</script>
